module cmult_tb;
  logic clk, reset, go;
  logic [3:-12] a_r, a_i, b_r, b_i;
  logic [7:-24] p_r, p_i;
  
  cmult dut(.clk(clk), .reset(reset), .go(go),
 	.a_r(a_r), .a_i(a_i), .b_r(b_r), .b_i(b_i),
	.p_r(p_r), .p_i(p_i));
  
  initial begin
    clk = 1; forever #5 clk = ~clk;
  end

  initial begin
    reset = 1;
	a_r = {4'h3,12'h000}; // a = 3 + 2i
	a_i = {4'h2,12'h000};
	b_r = {4'h5,12'h000}; // b = 5 + 4i
	b_i = {4'h4,12'h000};
	go = 0;
    #10 reset = 0;
	#1 go = 1;
    #10 go = 0;
	$monitor("%3d p_r=%2h.%6h p_i=%2h.%6h", $time,
		p_r[7:0], p_r[-1:-24],
		p_i[7:0], p_i[-1:-24]);
		// p = 7 + 22i (=07.0000 + 16.0000i in hex)
	#50 $stop;
  end

  initial $dumpvars(0, cmult_tb);
endmodule
